#include "defines.h"
#include "intr.h"
#include "interrupt.h"
#include "kozos.h"
#include "lib.h"
#include "armpsr.h"

/* 
 * 㳰ϥɥ (̤̿)
 * 㳰ȯɥ쥹ɽưߤ
 */
void exception_undef(unsigned long sp)
{
  unsigned long pc, spsr;

  /* ¸줿ƥȤ顢PCSPSR */
  spsr = *(unsigned long *)(sp + 0);
  pc = *(unsigned long *)(sp + 12);

  /* ARM/Thumb⡼ɤ˱㳰ȯPCͤɽ */
  puts("Undefined instruction at ");
  putxval((spsr & PSR_T) ? (pc - 2) : (pc - 4), 8);
  putc('\n');

  /* ưߤ */
  while (1);
}

/* 
 * 㳰ϥɥ (SWI)
 * ƤӽФSWI̿ᤫߥ٥
 */
void exception_swi(unsigned long sp)
{
  softvec_type_t type;
  unsigned long pc, spsr;

  /* ¸줿ƥȤ顢PCSPSR */
  spsr = *(unsigned long *)(sp + 0);
  pc = *(unsigned long *)(sp + 12);

  /* ARM/Thumb⡼ɤ˱ƤӽФSWI̿򻲾Ȥ */
  if (spsr & PSR_T) {
	  type = *(unsigned short *)(pc - 2);
  } else {
	  type = *(unsigned long *)(pc - 4);
  }

  /* ͭʥ٥ֹϡ0255ϰϤȤ */
  type &= 0xff;

  thread_intr(type, sp);
}

/* 
 * 㳰ϥɥ (ץեåܡ)
 * 㳰ȯɥ쥹ɽưߤ
 */
void exception_prefetch_abort(unsigned long sp)
{
  unsigned long pc;

  /* ¸줿ƥȤ顢PC */
  pc = *(unsigned long *)(sp + 12);

  /* 㳰ȯPCͤɽ */
  puts("Prefetch Abort at ");
  putxval(pc - 4, 8);
  putc('\n');

  /* ưߤ */
  while (1);
}

/* 
 * 㳰ϥɥ (ǡܡ)
 * 㳰ȯɥ쥹ɽưߤ
 */
void exception_data_abort(unsigned long sp)
{
  unsigned long pc;

  /* ¸줿ƥȤ顢PC */
  pc = *(unsigned long *)(sp + 12);

  /* 㳰ȯPCͤɽ */
  puts("Data Abort at ");
  putxval(pc - 8, 8);
  putc('\n');

  /* ưߤ */
  while (1);
}

/* 
 * 㳰ϥɥ (IRQ)
 * ߥȥ餫ߥ٥
 */
void exception_irq(unsigned long sp)
{
  softvec_type_t type = intc_vector();

  thread_intr(type, sp);
}
