#include "defines.h"
#include "interrupt.h"
#include "intr.h"

/* $B3d$j9~$_%3%s%H%m!<%i(B(Vectored Interrupt Controller)$B$NDj5A(B */
#define VICBase			0xfffff000
#define VICIRQStatus		(volatile uint32 *)(VICBase + 0x0000)
#define VICFIQStatus		(volatile uint32 *)(VICBase + 0x0004)
#define VICRawIntr		(volatile uint32 *)(VICBase + 0x0008)
#define VICIntSelect		(volatile uint32 *)(VICBase + 0x000c)
#define VICIntEnable		(volatile uint32 *)(VICBase + 0x0010)
#define VICIntEnClr		(volatile uint32 *)(VICBase + 0x0014)
#define VICSoftInt		(volatile uint32 *)(VICBase + 0x0018)
#define VICSoftIntClear		(volatile uint32 *)(VICBase + 0x001c)

/* $B3d$j9~$_%3%s%H%m!<%i$N=i4|2=(B */
void intc_init(void)
{
  *VICIntEnClr = ~0;     /* $BA4$F$N3d$j9~$_$r6X;_(B */
  *VICIntSelect = 0;     /* $BA4$F$N3d$j9~$_$r(BIRQ$B$H$9$k(B */
  *VICSoftIntClear = ~0; /* $BA4$F$N%=%U%H%&%'%"3d$j9~$_MW5a$r6X;_(B */
}

/* $B3d$j9~$_MW0x$N5v2D(B */
void intc_enable(softvec_type_t type)
{
  *VICIntEnable = 1 << (type & 0x1f);
}

/* $B3d$j9~$_MW0x$N6X;_(B */
void intc_disable(softvec_type_t type)
{
  *VICIntEnClr = 1 << (type & 0x1f);
}

/* $B3d$j9~$_%Y%/%?HV9f$N<hF@(B */
softvec_type_t intc_vector(void)
{
  softvec_type_t type = SOFTVEC_TYPE_IRQ(0);
  unsigned long status = *(volatile unsigned long *)VICIRQStatus;

  /* $B%9%F!<%?%9%U%i%0$N!"(B'1'$B$H$J$C$F$$$k%S%C%H$NHV9f$rF@$k(B */
  // $BM%@h=g0L$O(Bbit31($BDc(B)$B!A(Bbit0($B9b(B)$B$H$9$k(B
  // $B%9%F!<%?%9%U%i%0$,A4$F(B'0'$B$H$J$C$F$$$k>l9g$O!"(Btype=31$B$H$9$k(B
  if (!(status & 0xffff)) {
    status >>= 16;
    type += 16;
  }
  if (!(status & 0x00ff)) {
    status >>= 8;
    type += 8;
  }
  if (!(status & 0x000f)) {
    status >>= 4;
    type += 4;
  }
  if (!(status & 0x0003)) {
    status >>= 2;
    type += 2;
  }
  if (!(status & 0x0001)) {
    status >>= 1;
    type += 1;
  }

  return type;
}
