#include "armpsr.h"

/* $B3d$j9~$_%Y%/%?!'Nc30MW0x$KBP$9$k=hM}$r9T$&(B */

	.section .vector, "ax"
	.arm
	.align 0
	.global __start
__start:
	b	start_entry
undef_vector:
	b	undef_entry
swi_vector:
	b	swi_entry
prefetch_abort_vector:
	b	prefetch_abort_entry
data_abort_vector:
	b	data_abort_entry
reserved_vector:
	b	reserved_vector		// $BHsBP1~(B
irq_vector:
	b	irq_entry
fiq_vector:
	b	fiq_vector		// $BHsBP1~(B

/* $B%9%?!<%H%"%C%W(B */

	.section .text
	.arm
	.align 0
	.global start_entry

start_entry:
	/* $B3F<o%9%?%C%/$r=i4|2=(B */
	msr	cpsr_fsxc, #(PSR_M_SYS | PSR_I | PSR_F)
	ldr	sp, =_sys_stack
	msr	cpsr_fsxc, #(PSR_M_UND | PSR_I | PSR_F)
	ldr	sp, =_und_stack
	msr	cpsr_fsxc, #(PSR_M_ABT | PSR_I | PSR_F)
	ldr	sp, =_abt_stack
	msr	cpsr_fsxc, #(PSR_M_FIQ | PSR_I | PSR_F)
	ldr	sp, =_fiq_stack
	msr	cpsr_fsxc, #(PSR_M_IRQ | PSR_I | PSR_F)
	ldr	sp, =_irq_stack
	msr	cpsr_fsxc, #(PSR_M_SVC | PSR_I | PSR_F)
	ldr	sp, =_svc_stack

	/* OS$BK\BN$O(BSVC$B%b!<%I$GF0:n$7!"%f!<%6%W%m%0%i%`$O(BSYS$B%b!<%I$GF0:n$9$k(B */
start_main:
	mov	r0, #0
	bl	main

	/* $BK=AvKI;_MQ$NL58B%k!<%W(B */
1:
	b	1b

	.pool

/*
 * $B%3%s%F%-%9%H$N%l%$%"%&%H(B
 *
 * $B0J2<$N=gHV$G%3%s%F%-%9%H!J%l%8%9%?!K$rJ]B8$9$k!#(B
 *
 *	     +-------------+
 *	+  0 | SPSR_xxx    |	xxx: $BNc30H/@8;~$N(BCPU$B%b!<%I(B
 *	+  4 | R0          |
 *	+  8 | R1          |
 *	+ 12 | R14_xxx(PC) |
 *	     +=============+
 *	+ 16 | R2          |
 *	+ 20 | R3          |
 *	+ 24 | R4          |
 *	+ 28 | R5          |
 *	+ 32 | R6          |
 *	+ 36 | R7          |
 *	+ 40 | R8          |
 *	+ 44 | R9          |
 *	+ 48 | R10         |
 *	+ 52 | R11         |
 *	+ 56 | R12         |
 *	+ 60 | R14_sys     |
 *	     +-------------+
 */

/*
 * $BNc30=hM}MQ%^%/%m!'Nc30=hM}3+;O!J%3%s%F%-%9%HJ]B8!K(B
 *
 * R13_xxx$B%l%8%9%?$K@_Dj$7$?Nc30MQ%9%?%C%/$r;HMQ$7$F!"(BR13_sys$B%l%8%9%?$G(B
 * $B<($5$l$k%9%?%C%/$K%3%s%F%-%9%H$rJ]B8$9$k!#(B
 * USR, SYS$B%b!<%I0J30$N(BCPU$B%b!<%I$+$i$3$N%^%/%m$r8F$S=P$7!"8F$S=P$78e$N(B
 * CPU$B%b!<%I$O(BSVC, $B3d$j9~$_$OA4$F6X;_$H$9$k!#(B
 */
.macro	EIT_ENTER
	/* $B0l;~%9%?%C%/$K(BSPSR, R0, R1, PC$B$rJ]B8(B */
	stmfd	sp!, {r0, r1, lr}
	mrs	r0, spsr
	stmfd	sp!, {r0}
	mrs	r1, cpsr

	/* SYS$B%b!<%I$N%l%8%9%?$rJ]B8(B */
	msr	cpsr_c, #(PSR_M_SYS | PSR_I | PSR_F)
	stmfd	sp!, {r2-r12, r14}
	sub	sp, sp, #0x10		// $B0l;~%9%?%C%/J]B8MQNN0h$r3NJ](B
	mov	r0, sp

	/* $B0l;~%9%?%C%/$NFbMF$r0\F0(B */
	orr	r1, r1, #(PSR_I | PSR_F)
	msr	cpsr_c, r1
	ldmfd	sp!, {r1-r4}

	msr	cpsr_c, #(PSR_M_SVC | PSR_I | PSR_F)
	stm	r0, {r1-r4}
.endm

/*
 * $BNc30=hM}MQ%^%/%m!'Nc30=hM}=*N;!J%3%s%F%-%9%HI|5"!K(B
 *
 * R0$B%l%8%9%?$N<($9%3%s%F%-%9%H$rI|5"$9$k!#(B
 * $B%^%/%m8F$S=P$7;~$N(BCPU$B%b!<%I$O!"(BSVC$B%b!<%I$K8BDj$9$k!#(B
 */
.macro	EIT_LEAVE
	/* $BJ]B8$5$l$F$$$k(BSPSR, R0, R1, PC$B$r0l;~%9%?%C%/$K0\F0(B */
	ldmfd	r0!, {r1-r3, r12}
	stmfd	sp!, {r1-r3, r12}

	/* SYS$B%b!<%I$N%l%8%9%?$rI|5"(B */
	msr	cpsr_c, #(PSR_M_SYS | PSR_I | PSR_F)
	mov	sp, r0
	ldmfd	sp!, {r2-r12, r14}

	/* CPU$B%b!<%I$r(BSVC$B%b!<%I$K@Z$jBX$($k(B */
	msr	cpsr_c, #(PSR_M_SVC | PSR_I | PSR_F)
	ldmfd	sp!, {r0}
	msr	spsr_fsxc, r0
	ldmfd	sp!, {r0, r1, pc}^
.endm

/* $BNc30=hM}%(%s%H%j!'L$Dj5AL?Na(B */
undef_entry:
	EIT_ENTER
	mov	r4, r0
	bl	exception_undef
	mov	r0, r4
	EIT_LEAVE

/* $BNc30=hM}%(%s%H%j!'(BSWI */
swi_entry:
	EIT_ENTER
	mov	r4, r0
	bl	exception_swi
	mov	r0, r4
	EIT_LEAVE

/* $BNc30=hM}%(%s%H%j!'%W%j%U%'%C%A%"%\!<%H(B */
prefetch_abort_entry:
	EIT_ENTER
	mov	r4, r0
	bl	exception_prefetch_abort
	mov	r0, r4
	EIT_LEAVE

/* $BNc30=hM}%(%s%H%j!'%G!<%?%"%\!<%H(B */
data_abort_entry:
	EIT_ENTER
	mov	r4, r0
	bl	exception_data_abort
	mov	r0, r4
	EIT_LEAVE

/* $BNc30=hM}%(%s%H%j!'(BIRQ */
irq_entry:
	sub	lr, lr, #4	// $BI|5"%"%I%l%9D4@0(B
	EIT_ENTER
	mov	r4, r0
	bl	exception_irq
	mov	r0, r4
	EIT_LEAVE

/* $B%G%#%9%Q%C%A(B */
	.global dispatch
dispatch:
	ldr	r0, [r0]
	EIT_LEAVE

	.pool

/* $B3d$j9~$_6X;_(B */
	.global intr_disable
intr_disable:
	mrs	r0, cpsr
	orr	r0, r0, #(PSR_I | PSR_F)
	msr	cpsr_c, r0
	bx	lr

/* $B3d$j9~$_5v2D(B */
intr_enable:
	.global intr_enable
	mrs	r0, cpsr
	bic	r0, r0, #(PSR_I | PSR_F)
	msr	cpsr_c, r0
	bx	lr
